using System;

namespace ElasticBand
{
	public class Junction
	{
		private Punkt startpunkt;
		private Punkt endpunkt;

		private double entfernung;

		private const double stanLang = 10;

		public Junction(Punkt startpunkt, Punkt endpunkt)
		{
			this.endpunkt = endpunkt;
			this.startpunkt = startpunkt;
		}

		public void Berechne()
		{
			float gummiZug = 0.002f;

			entfernung = Tools.BerechneEntfernung(endpunkt.Coords.X, startpunkt.Coords.X, endpunkt.Coords.Y, startpunkt.Coords.Y);
			
			float correction = gummiZug * (float)Math.Sqrt(entfernung);

			if(entfernung > stanLang)
			{
				if(endpunkt.Coords.X > startpunkt.Coords.X) // Endpunkt ist RECHTS von startpunkt
				{
					endpunkt.Velocity.X -= correction;
					startpunkt.Velocity.X += correction;
				}
				else // Endpunkt ist LINKS von Startpunkt
				{
					endpunkt.Velocity.X += correction;
					startpunkt.Velocity.X -= correction;
				}

				if(endpunkt.Coords.Y > startpunkt.Coords.Y) // Endpunkt ist BER von startpunkt
				{
					endpunkt.Velocity.Y -= correction;
					startpunkt.Velocity.Y += correction;
				}
				else // Endpunkt ist UNTER von Startpunkt
				{
					endpunkt.Velocity.Y += correction;
					startpunkt.Velocity.Y -= correction;
				}
			}
		}

		public Punkt Startpunkt
		{
			get { return startpunkt; }
			set { startpunkt = value; }
		}

		public Punkt Endpunkt
		{
			get { return endpunkt; }
			set { endpunkt = value; }
		}
	}
}